// Decompiled by JEB v1.5.201408040 - http://www.android-decompiler.com

package com.my.api;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.CharArrayWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;

public class Base64 {
    private static char[] alphabet;
    private static byte[] codes;

    static {
        int v3 = 256;
        Base64.alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".toCharArray();
        Base64.codes = new byte[v3];
        int v0;
        for(v0 = 0; v0 < v3; ++v0) {
            Base64.codes[v0] = -1;
        }

        for(v0 = 65; v0 <= 90; ++v0) {
            Base64.codes[v0] = ((byte)(v0 - 65));
        }

        for(v0 = 97; v0 <= 122; ++v0) {
            Base64.codes[v0] = ((byte)(v0 - 71));
        }

        for(v0 = 48; v0 <= 57; ++v0) {
            Base64.codes[v0] = ((byte)(v0 + 4));
        }

        Base64.codes[43] = 62;
        Base64.codes[47] = 63;
    }

    public Base64() {
        super();
    }

    public static byte[] decode(String data) {
        return Base64.decode(data.toCharArray());
    }

    public static byte[] decode(char[] data) {
        int v11 = 255;
        int v7 = data.length;
        int v3;
        for(v3 = 0; v3 < data.length; ++v3) {
            if(data[v3] > v11 || Base64.codes[data[v3]] < 0) {
                --v7;
            }
        }

        int v4 = v7 / 4 * 3;
        if(v7 % 4 == 3) {
            v4 += 2;
        }

        if(v7 % 4 == 2) {
            ++v4;
        }

        byte[] v5 = new byte[v4];
        int v6 = 0;
        int v0 = 0;
        int v1 = 0;
        for(v3 = 0; v3 < data.length; ++v3) {
            int v8 = data[v3] > v11 ? -1 : Base64.codes[data[v3]];
            if(v8 >= 0) {
                v6 += 6;
                v0 = v0 << 6 | v8;
                if(v6 >= 8) {
                    v6 += -8;
                    v5[v1] = ((byte)(v0 >> v6 & 255));
                    ++v1;
                }
            }
        }

        if(v1 != v5.length) {
            throw new Error("Miscalculated data length (wrote " + v1 + " instead of " + v5.length + ")");
        }

        return v5;
    }

    public static char[] encode(byte[] data) {
        int v7 = 64;
        char[] v2 = new char[(data.length + 2) / 3 * 4];
        int v0 = 0;
        int v1;
        for(v1 = 0; v0 < data.length; v1 += 4) {
            int v3 = 0;
            int v4 = 0;
            int v5 = (data[v0] & 255) << 8;
            if(v0 + 1 < data.length) {
                v5 |= data[v0 + 1] & 255;
                v4 = 1;
            }

            v5 <<= 8;
            if(v0 + 2 < data.length) {
                v5 |= data[v0 + 2] & 255;
                v3 = 1;
            }

            int v8 = v1 + 3;
            char[] v9 = Base64.alphabet;
            int v6 = v3 != 0 ? v5 & 63 : v7;
            v2[v8] = v9[v6];
            v5 >>= 6;
            v8 = v1 + 2;
            v9 = Base64.alphabet;
            v6 = v4 != 0 ? v5 & 63 : v7;
            v2[v8] = v9[v6];
            v5 >>= 6;
            v2[v1 + 1] = Base64.alphabet[v5 & 63];
            v2[v1] = Base64.alphabet[v5 >> 6 & 63];
            v0 += 3;
        }

        return v2;
    }

    public static String encodeToString(byte[] data) {
        return new String(Base64.encode(data));
    }

    public static void main(String[] args) {
        int v0 = 0;
        if(args.length == 0) {
            System.out.println("usage:  java Base64 [-d[ecode]] filename");
            System.exit(0);
        }

        int v5;
        for(v5 = 0; v5 < args.length; ++v5) {
            if("-decode".equalsIgnoreCase(args[v5])) {
                v0 = 1;
            }
            else if("-d".equalsIgnoreCase(args[v5])) {
                v0 = 1;
            }
        }

        String v4 = args[args.length - 1];
        File v3 = new File(v4);
        if(!v3.exists()) {
            System.out.println("Error:  file \'" + v4 + "\' doesn\'t exist!");
            System.exit(0);
        }

        if(v0 != 0) {
            Base64.writeBytes(v3, Base64.decode(Base64.readChars(v3)));
        }
        else {
            Base64.writeChars(v3, Base64.encode(Base64.readBytes(v3)));
        }
    }

    private static byte[] readBytes(File file) {
        int v2;
        byte[] v1;
        BufferedInputStream v4;
        ByteArrayOutputStream v0 = new ByteArrayOutputStream();
        try {
            v4 = new BufferedInputStream(new FileInputStream(file));
            v1 = new byte[16384];
            while(true) {
            label_9:
                v2 = ((InputStream)v4).read(v1);
                if(v2 != -1) {
                    break;
                }

                goto label_12;
            }
        }
        catch(Exception v5) {
            goto label_20;
        }

        if(v2 <= 0) {
            goto label_9;
        }

        try {
            v0.write(v1, 0, v2);
            goto label_9;
        label_12:
            ((InputStream)v4).close();
        }
        catch(Exception v5) {
        label_20:
        }

        return v0.toByteArray();
    }

    private static char[] readChars(File file) {
        int v2;
        char[] v0;
        BufferedReader v4;
        CharArrayWriter v1 = new CharArrayWriter();
        try {
            v4 = new BufferedReader(new FileReader(file));
            v0 = new char[16384];
            while(true) {
            label_9:
                v2 = ((Reader)v4).read(v0);
                if(v2 != -1) {
                    break;
                }

                goto label_12;
            }
        }
        catch(Exception v5) {
            goto label_20;
        }

        if(v2 <= 0) {
            goto label_9;
        }

        try {
            v1.write(v0, 0, v2);
            goto label_9;
        label_12:
            ((Reader)v4).close();
        }
        catch(Exception v5) {
        label_20:
        }

        return v1.toCharArray();
    }

    private static void writeBytes(File file, byte[] data) {
        try {
            BufferedOutputStream v2 = new BufferedOutputStream(new FileOutputStream(file));
            ((OutputStream)v2).write(data);
            ((OutputStream)v2).close();
        }
        catch(Exception v0) {
            v0.printStackTrace();
        }
    }

    private static void writeChars(File file, char[] data) {
        try {
            BufferedWriter v1 = new BufferedWriter(new FileWriter(file));
            ((Writer)v1).write(data);
            ((Writer)v1).close();
        }
        catch(Exception v2) {
        }
    }
}

